Name: fpc
Version: 2.1
Release: alt3

Summary: Free Pascal Compiler
License: GPL
Group: Development/Other

URL: http://www.freepascal.org

Source: fpc-%version-%release.tar

ExclusiveOS: Linux
ExclusiveArch: %ix86 amd64 x86_64

# for smartlink-ldflags.patch
Requires: binutils >= 1:2.15.92
BuildPreReq: binutils >= 1:2.15.92

# Automatically added by buildreq on Thu Feb 01 2007 (-bi)
BuildRequires: fpc fpcmake rpm-build-fpc

%description
The Free Pascal Compiler is a Turbo Pascal 7.0 and Delphi compatible
32/64-bit Pascal Compiler. It comes with a fully compatible TP 7.0
runtime library.  Some extensions are added to the language, like
function overloading.  Basic Delphi support is already implemented
(classes, exceptions, ansistrings).

%prep
%setup -q -n fpc-%version-%release

%build
(cd compiler; fpcmake -r -Tall)
(cd rtl; fpcmake -r -Tall)

%define ppcname %(basename `fpc -PB`)
make -C compiler cycle RELEASE=1
cp -pv compiler/%ppcname %ppcname

rm compiler/msg*.inc

%fpc_build FPC=$PWD/%ppcname FPCDIR=$PWD -C rtl
%fpc_build FPC=$PWD/%ppcname FPCDIR=$PWD -C compiler

%ifnarch %ix86
%fpc_make FPC=$PWD/%ppcname FPCDIR=$PWD CROSSINSTALL=1 PPC_TARGET=i386 -C compiler
cp -pv compiler/ppc386 ppc386
%endif

%fpc_build_win32 FPC=$PWD/ppc386 FPCDIR=$PWD -C rtl

%install
%fpc_install FPC=$PWD/%ppcname FPCDIR=$PWD -C rtl
%fpc_install FPC=$PWD/%ppcname FPCDIR=$PWD -C compiler
install -pD -m755 compiler/msg2inc %buildroot%_bindir/msg2inc

# this symbolic link must be absolute (so that fpcmake can detect FPCDIR)
ln -s %fpc_dir/%ppcname %buildroot%_bindir/%ppcname

%ifnarch %ix86
install -pD -m755 ppc386 %buildroot%fpc_dir/ppc386
ln -s %fpc_dir/ppc386 %buildroot%_bindir/ppc386
%endif

%fpc_install_win32 FPC=$PWD/ppc386 FPCDIR=$PWD -C rtl

mkdir -p %buildroot%_man1dir %buildroot%_man5dir
install -p -m644 man/man1/*.1 %buildroot%_man1dir/
install -p -m644 man/man5/*.5 %buildroot%_man5dir/

# quick sanity test
rtl=$(find %buildroot%fpc_dir -wholename '*-linux/rtl/system.ppu' -printf '%%h')
%buildroot%fpc_dir/%ppcname -n -Fu$rtl test.pas
./test

%ifarch %ix86
install -p -m644 compiler/i386/units/i386-linux/*.* ${rtl%%/rtl}/compiler/
%else
install -p -m644 compiler/x86_64/units/x86_64-linux/*.* ${rtl%%/rtl}/compiler/
%endif

%files
%_bindir/fpc
%_bindir/%ppcname
%_bindir/ppudump
%_bindir/ppufiles
%_bindir/ppumove
%_bindir/msg2inc
%fpc_dir/msg
%fpc_dir/%ppcname
%fpc_dir/samplecfg
%_man1dir/fpc.1*
%_man1dir/ppudump.1*
%_man1dir/ppufiles.1*
%_man1dir/ppumove.1*
%_man5dir/fpc.cfg.5*
# rtl
%fpc_files *-linux rtl

%package win32
Summary: Free Pascal runtime library units cross-compiled for win32
Group: Development/Other
Requires: %name = %version-%release

%description win32
The Free Pascal Compiler is a Turbo Pascal 7.0 and Delphi compatible
32/64-bit Pascal Compiler. It comes with a fully compatible TP 7.0
runtime library.

%files win32
%ifnarch %ix86
%_bindir/ppc386
%fpc_dir/ppc386
%endif
%fpc_files *-win32 rtl

%package compunits
Summary: Free Pascal compiler internal units
Group: Development/Other
Requires: %name = %version-%release

%description compunits
The Free Pascal Compiler is a Turbo Pascal 7.0 and Delphi compatible
32/64-bit Pascal Compiler. It comes with a fully compatible TP 7.0
runtime library.

%files compunits
%fpc_files *-linux compiler

%changelog
* Thu Feb 01 2007 Alexey Tourbin <at@altlinux.ru> 2.1-alt3
- updated to svn revision 6276

* Sun Jan 21 2007 Alexey Tourbin <at@altlinux.ru> 2.1-alt2
- updated to svn revision 6095 (fixes x86_64 build)
- packaged %_bindir/msg2inc

* Thu Jan 18 2007 Alexey Tourbin <at@altlinux.ru> 2.1-alt1
- this release is based on 2.1 development branch
- imported compiler/ and rtl/ from svn trunk; adapted for gear
- packaged internal compiler units into fpc-compunits package
- rtl/inc/videoh.inc: changed max screen width from 132 to 240
- fpc-win32: removed mingw32 binutils dependency (internal linker on)

* Sat Sep 16 2006 Alexey Tourbin <at@altlinux.ru> 2.0.4-alt2.1
- removed fpcmake from build requires; this should now build
  on x86_64, but will fail on i586, which is ok

* Sat Sep 16 2006 Alexey Tourbin <at@altlinux.ru> 2.0.4-alt2
- don't strip static libraries

* Sun Sep 10 2006 Alexey Tourbin <at@altlinux.ru> 2.0.4-alt1
- 2.0.2 -> 2.0.4+ (svn revision 4597)
- only fpc and rtl packaged now from here; buncha funky wild-ass
  units to be packaged separately
- fpc-win32 now works on x86_84 (as well as x86)

* Tue May 02 2006 Alexey Tourbin <at@altlinux.ru> 2.0.2-alt1
- 2.0.0 -> 2.0.2, Sisyphus release
- x86_64 build ok
- subpackages: fpc, fpc-utils, fpc-packages, fpc-ide, etc.;
  fpc-win32: cross-compile for win32 (i586 only)
- docs will be packaged separately
- TODO: examples unpackaged

* Fri Oct 21 2005 Alexey Tourbin <at@altlinux.ru> 2.0.0-alt1
- 1.0.10 -> 2.0.0
- fpcdir:='%_libdir/fpc2'; fpcdocdir:='%_docdir/fpc2'
- forward release for Daedalus

* Tue Feb 11 2004 Sergey P. Kondratyev <seirge@altlinux.ru> 1.0.10-alt1
- new version + docs and examples

* Mon Oct 07 2002 Michael Shigorin <mike@altlinux.ru> 1.0.6-alt1.1
- spec cleanup

* Sat Sep 19 2002 Sergey <skrivulja@erec.ru>
- adopted for Master
